/* ************************************************************************** */
/*                                       _____           _                    */
/*  bcd/is_zero.c                       |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libg1m                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/11/21 16:07:53                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libg1m/internals.h>
#include <libg1m/internals/bcd.h>

/**
 *	g1m_bcd_is_nonzero:
 *	Check if a BCD is zero.
 *
 *	@arg	bcd		pointer to the bcd.
 *	@return			true or false.
 */

int g1m_bcd_is_nonzero(struct bcd *bcd)
{
	static struct bcd ref = {.BCDval = {}};
	unsigned char *bytes = bcd->BCDval;

	return (lwr(1) | memcmp(&bytes[2], &ref.BCDval[2], 7));
}
