/* ************************************************************************** */
/*                                       _____           _                    */
/*  strerror.c                          |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libg1m                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/10/31 00:14:27                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libg1m/internals.h>

/**
 *	g1m_error_strings:
 *	String descriptions of libg1m errors.
 *
 *	This list MUST evolve whenever the g1m_error_t enumeration
 *	is updated. Could cause invalid error strings otherwise,
 *	or segfaults!
 */

const char *g1m_error_strings[] = {
	[g1m_noerror] =
	"no error have been encountered",

	[g1m_error_nostream] =
	"sent stream was NULL",
	[g1m_error_noread] =
	"given stream was not readable",
	[g1m_error_noseek] =
	"given stream was not seekable",

	[g1m_error_magic] =
	"magic/control problem",
	[g1m_error_eof] =
	"unexpected EOF",
	[g1m_error_alloc] =
	"could not allocate memory",

	[g1m_error_op] =
	"operation is unsupported for this type"
};
