/* ************************************************************************** */
/*                                       _____           _                    */
/*  user/make.c                         |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libg1m                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/12/15 13:22:04                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libg1m/internals.h>

/**
 *	g1m_make_mcs:
 *	Make an MCS file.
 *
 *	@arg	h		pointer to the handle to create.
 *	@return			the error code (0 if ok).
 */

int g1m_make_mcs(g1m_t **h)
{
	/* allocate the handle */
	*h = malloc(sizeof(g1m_t));
	if (!*h) return (g1m_error_alloc);

	/* initialize it */
	g1m_t *handle = *h;
	handle->type = g1m_type_mcs;
	handle->is_cg = 0;
	handle->count = 0;
	handle->_size = 0;
	handle->files = NULL;

	/* no error */
	return (0);
}
