/* ************************************************************************** */
/*                                       _____           _                    */
/*  utils/checksum32.c                  |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libg1m                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/11/25 13:49:54                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libg1m/internals.h>

/**
 *	g1m_checksum32:
 *	Make checksums great again.
 *
 *	@arg	mem				the memory zone
 *	@arg	size			the memory zone size
 *	@arg	checksum		current checksum
 *	@return					the new checksum
 */

uint32_t g1m_checksum32(void *mem, size_t size, uint32_t checksum)
{
	uint8_t *m = mem;

	while (size--)
		checksum += *m++;
	return (checksum);
}
